> For clean Markdown of any page, append .md to the page URL.
> For a complete documentation index, see https://docs.nvidia.com/infra-controller/llms.txt.
> For AI client integration (Claude Code, Cursor, etc.), connect to the MCP server at https://docs.nvidia.com/infra-controller/_mcp/server.

# Create an on-demand Machine validation run

POST https://nico-rest-api.nico.svc.cluster.local/v2/org/{org}/nico/machine/{machineId}/validation/run
Content-Type: application/json

Create an on-demand Machine validation run. The Machine must be in a state accepted by NICo Core.

Org must have an Infrastructure Provider entity and own the Site that the Machine belongs to. User must have authorization role with `PROVIDER_ADMIN` suffix.

Reference: https://docs.nvidia.com/infra-controller/infra-controller/rest-api-reference/api-reference/machine-validation/start-machine-validation

## Authentication

- `Authorization` header (bearer token, required) — ``` export JWT_BEARER_TOKEN="<jwt-bearer-token>" # Example org name: "acme-inc export ORG_NAME=<org-name> # Use the JWT bearer token in your API request auth header: curl -v -X GET -H "Content-Type: application/json" -H "Authorization: Bearer $JWT_BEARER_TOKEN" https://nico-rest-api.nico.svc.cluster.local/v2/org/$ORG_NAME/nico/user/current ```

## Request

### Path parameters

- `org` (string, required) — Name of the Org
- `machineId` (string, required) — ID of the Machine

### Body (application/json)

- `tags` (list of string, optional) — Tags used to select validation tests.
- `allowedTests` (list of string, optional) — Validation test names allowed for this run.
- `runUnverifiedTests` (boolean, optional, default: false) — Whether unverified validation tests may run.
- `contexts` (list of string, optional) — Contexts used to select validation tests.

## Response

### 202

On-demand Machine validation request was accepted

- `validationID` (string, required) — ID of the Machine validation run.
- `machineID` (string, required) — ID of the validated Machine.
- `startTime` (datetime, required) — Time the validation run started.
- `endTime` (datetime, required, nullable) — Time the validation run completed, or null while it is active.
- `name` (string, required) — Name of the validation run.
- `context` (string, required) — Context in which the validation run was created.
- `status` (object, required) — Progress and outcome of a Machine validation run
  - `state` (enum, required) — Current state or completed outcome of the validation run.
    - Allowed values: `Started`, `InProgress`, `Success`, `Failed`, `Skipped`
  - `total` (integer, required) — Total number of validation tests in the run.
  - `completed` (integer, required) — Number of validation tests that have completed.
- `durationToCompleteSecs` (integer, required) — Estimated maximum duration of the validation run in seconds. A value of zero can mean the estimate has not yet been calculated.

## Examples

**Request**

```json
{
  "tags": [
    "dgxcloud"
  ],
  "allowedTests": [
    "forge_DcgmFullLong"
  ],
  "runUnverifiedTests": false,
  "contexts": [
    "OnDemand"
  ]
}
```

**Response**

```json
{
  "validationID": "20000000-0000-0000-0000-000000000001",
  "machineID": "fm100htes3rn1npvbtm5qd57dkilaag7ljugl1llmm7rfuq1ov50i0rpl30",
  "startTime": "2026-08-03T20:00:00Z",
  "endTime": null,
  "name": "Test_fm100htes3rn1npvbtm5qd57dkilaag7ljugl1llmm7rfuq1ov50i0rpl30",
  "context": "OnDemand",
  "status": {
    "state": "InProgress",
    "total": 1,
    "completed": 0
  },
  "durationToCompleteSecs": 7200
}
```

**SDK Code**

```python
import requests

url = "https://nico-rest-api.nico.svc.cluster.local/v2/org/org/nico/machine/machineId/validation/run"

payload = {
    "tags": ["dgxcloud"],
    "allowedTests": ["forge_DcgmFullLong"],
    "runUnverifiedTests": False,
    "contexts": ["OnDemand"]
}
headers = {
    "Authorization": "Bearer <token>",
    "Content-Type": "application/json"
}

response = requests.post(url, json=payload, headers=headers)

print(response.json())
```

```javascript
const url = 'https://nico-rest-api.nico.svc.cluster.local/v2/org/org/nico/machine/machineId/validation/run';
const options = {
  method: 'POST',
  headers: {Authorization: 'Bearer <token>', 'Content-Type': 'application/json'},
  body: '{"tags":["dgxcloud"],"allowedTests":["forge_DcgmFullLong"],"runUnverifiedTests":false,"contexts":["OnDemand"]}'
};

try {
  const response = await fetch(url, options);
  const data = await response.json();
  console.log(data);
} catch (error) {
  console.error(error);
}
```

```go
package main

import (
	"fmt"
	"strings"
	"net/http"
	"io"
)

func main() {

	url := "https://nico-rest-api.nico.svc.cluster.local/v2/org/org/nico/machine/machineId/validation/run"

	payload := strings.NewReader("{\n  \"tags\": [\n    \"dgxcloud\"\n  ],\n  \"allowedTests\": [\n    \"forge_DcgmFullLong\"\n  ],\n  \"runUnverifiedTests\": false,\n  \"contexts\": [\n    \"OnDemand\"\n  ]\n}")

	req, _ := http.NewRequest("POST", url, payload)

	req.Header.Add("Authorization", "Bearer <token>")
	req.Header.Add("Content-Type", "application/json")

	res, _ := http.DefaultClient.Do(req)

	defer res.Body.Close()
	body, _ := io.ReadAll(res.Body)

	fmt.Println(res)
	fmt.Println(string(body))

}
```

```ruby
require 'uri'
require 'net/http'

url = URI("https://nico-rest-api.nico.svc.cluster.local/v2/org/org/nico/machine/machineId/validation/run")

http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true

request = Net::HTTP::Post.new(url)
request["Authorization"] = 'Bearer <token>'
request["Content-Type"] = 'application/json'
request.body = "{\n  \"tags\": [\n    \"dgxcloud\"\n  ],\n  \"allowedTests\": [\n    \"forge_DcgmFullLong\"\n  ],\n  \"runUnverifiedTests\": false,\n  \"contexts\": [\n    \"OnDemand\"\n  ]\n}"

response = http.request(request)
puts response.read_body
```

```java
import com.mashape.unirest.http.HttpResponse;
import com.mashape.unirest.http.Unirest;

HttpResponse<String> response = Unirest.post("https://nico-rest-api.nico.svc.cluster.local/v2/org/org/nico/machine/machineId/validation/run")
  .header("Authorization", "Bearer <token>")
  .header("Content-Type", "application/json")
  .body("{\n  \"tags\": [\n    \"dgxcloud\"\n  ],\n  \"allowedTests\": [\n    \"forge_DcgmFullLong\"\n  ],\n  \"runUnverifiedTests\": false,\n  \"contexts\": [\n    \"OnDemand\"\n  ]\n}")
  .asString();
```

```php
<?php
require_once('vendor/autoload.php');

$client = new \GuzzleHttp\Client();

$response = $client->request('POST', 'https://nico-rest-api.nico.svc.cluster.local/v2/org/org/nico/machine/machineId/validation/run', [
  'body' => '{
  "tags": [
    "dgxcloud"
  ],
  "allowedTests": [
    "forge_DcgmFullLong"
  ],
  "runUnverifiedTests": false,
  "contexts": [
    "OnDemand"
  ]
}',
  'headers' => [
    'Authorization' => 'Bearer <token>',
    'Content-Type' => 'application/json',
  ],
]);

echo $response->getBody();
```

```csharp
using RestSharp;

var client = new RestClient("https://nico-rest-api.nico.svc.cluster.local/v2/org/org/nico/machine/machineId/validation/run");
var request = new RestRequest(Method.POST);
request.AddHeader("Authorization", "Bearer <token>");
request.AddHeader("Content-Type", "application/json");
request.AddParameter("application/json", "{\n  \"tags\": [\n    \"dgxcloud\"\n  ],\n  \"allowedTests\": [\n    \"forge_DcgmFullLong\"\n  ],\n  \"runUnverifiedTests\": false,\n  \"contexts\": [\n    \"OnDemand\"\n  ]\n}", ParameterType.RequestBody);
IRestResponse response = client.Execute(request);
```

```swift
import Foundation

let headers = [
  "Authorization": "Bearer <token>",
  "Content-Type": "application/json"
]
let parameters = [
  "tags": ["dgxcloud"],
  "allowedTests": ["forge_DcgmFullLong"],
  "runUnverifiedTests": false,
  "contexts": ["OnDemand"]
] as [String : Any]

let postData = JSONSerialization.data(withJSONObject: parameters, options: [])

let request = NSMutableURLRequest(url: NSURL(string: "https://nico-rest-api.nico.svc.cluster.local/v2/org/org/nico/machine/machineId/validation/run")! as URL,
                                        cachePolicy: .useProtocolCachePolicy,
                                    timeoutInterval: 10.0)
request.httpMethod = "POST"
request.allHTTPHeaderFields = headers
request.httpBody = postData as Data

let session = URLSession.shared
let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in
  if (error != nil) {
    print(error as Any)
  } else {
    let httpResponse = response as? HTTPURLResponse
    print(httpResponse)
  }
})

dataTask.resume()
```